#include <iostream>
#include <vector>
#include <cstdio>

using namespace std;

const int maxN = 100000;
const int maxK = 2000000;
const int inf = 1000000000;

// Let save the smallest prime divisor of number is this array
int sieve[maxK + 1], arr[maxN + 1];

int z, n, a;

vector<int> g[maxN + 1], number[maxK + 1], component;
int color[maxN + 1];

void precalcPrimes() {
    for (int i = 2; i <= maxK; ++i) {
        if (!sieve[i]) {
            for (int j = i; j <= maxK; j += i) {
                if (!sieve[j])
                    sieve[j] = i;
            }
        }
    }
}

void clear() {
    for (int i = 0; i <= maxK; ++i) {
        number[i].clear();
    }
    for (int i = 0; i <= maxN; ++i) {
        color[i] = -1;
        g[i].clear();
    }
}

int paint(int vertex, int curColor) {
    color[vertex] = curColor;
    int result = !curColor ? 1 : -1;
    component.push_back(vertex);
    for (int i = 0; i < g[vertex].size(); ++i) {
        int to = g[vertex][i];
        if (color[to] == -1) {
            int cur = paint(to, curColor ^ 1);
            if (cur == inf)
                return cur;
            result += cur;
        }
        if (color[vertex] == color[to]) {
            return inf;
        }
    }
    return result;
}

void Solve() {
    clear();
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) {
        scanf("%d", &arr[i]);
    }
    for (int i = 0; i < n; ++i) {
        a = arr[i];
        while (a != 1) {
            int divisor = sieve[a];
            number[divisor].push_back(i);
            if (number[divisor].size() > 2) {
                printf("-1\n");
                return;
            }
            while (a % divisor == 0) a /= divisor;
        }
    }
    for (int i = 0; i <= maxK; ++i) {
        if (number[i].size() == 2) {
            g[number[i][0]].push_back(number[i][1]);
            g[number[i][1]].push_back(number[i][0]);
        }
    }
    int size = 0;
    for (int i = 0; i < n; ++i) {
        if (color[i] == -1) {
            component.clear();
            int cnt = paint(i, 0);
            if (cnt == inf) {
                printf("-1\n");
                return;
            }
            if (cnt < 0) {
                for (int i = 0; i < component.size(); ++i) {
                    color[component[i]] ^= 1;
                }
            }
        }
        if (!color[i]) ++size;
    }
    printf("%d\n", size);
    for (int i = 0; i < n; ++i) {
        if (!color[i])
            printf("%d ", i + 1);
    }
    printf("\n");
}

int main() {
    precalcPrimes();
    scanf("%d", &z);
    for (int i = 0; i < z; ++i)
        Solve();
    return 0;
}
